Loading...
Searching...
No Matches
seqan3::dna16sam Class Reference
Alphabet » Nucleotide

A 16 letter DNA alphabet, containing all IUPAC symbols minus the gap and plus an equality sign ('='). More...

`#include <seqan3/alphabet/nucleotide/dna16sam.hpp>`

Inheritance diagram for seqan3::dna16sam:
[legend]

## Public Member Functions

Constructors, destructor and assignment
constexpr | dna16sam () noexcept=default
| Defaulted.
constexpr | dna16sam (dna16sam const &) noexcept=default
| Defaulted.
constexpr | dna16sam (dna16sam &&) noexcept=default
| Defaulted.
constexpr dna16sam & | operator= (dna16sam const &) noexcept=default
| Defaulted.
constexpr dna16sam & | operator= (dna16sam &&) noexcept=default
| Defaulted.
| ~dna16sam () noexcept=default
| Defaulted.
Public Member Functions inherited from seqan3::nucleotide_base< dna16sam, 16 >
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr dna16sam | complement () const noexcept
| Return the complement of the letter.
constexpr | nucleotide_base (other_nucl_type const &other) noexcept
| Allow explicit construction from any other nucleotide type and convert via the character representation.
Public Member Functions inherited from seqan3::alphabet_base< derived_type, size, char_t >
constexpr | alphabet_base () noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base const &) noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base &&) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base const &) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base &&) noexcept=default
| Defaulted.
| ~alphabet_base () noexcept=default
| Defaulted.
constexpr char_type | to_char () const noexcept
| Return the letter as a character of char_type.
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr derived_type & | assign_char (char_type const chr) noexcept
| Assign from a character, implicitly converts invalid characters.
constexpr derived_type & | assign_rank (rank_type const c) noexcept
| Assign from a numeric value.

## Related Symbols

(Note that these are not member symbols.)
using | dna16sam_vector = std::vector<dna16sam>
| Alias for a std::vector of seqan3::dna16sam.
Nucleotide literals
constexpr dna16sam | operator""_dna16sam (char const c) noexcept
| The seqan3::dna16sam char literal.
constexpr dna16sam_vector | operator""_dna16sam (char const *s, size_t n)
| The seqan3::dna16sam string literal.

## Additional Inherited Members

Static Public Member Functions inherited from seqan3::nucleotide_base< dna16sam, 16 >
static constexpr bool | char_is_valid (char_type const c) noexcept
| Validate whether a character value has a one-to-one mapping to an alphabet value.
Static Public Attributes inherited from seqan3::nucleotide_base< dna16sam, 16 >
static constexpr detail::min_viable_uint_t< size > | alphabet_size
| The size of the alphabet, i.e. the number of different values it can take.
Static Public Attributes inherited from seqan3::alphabet_base< derived_type, size, char_t >
static constexpr detail::min_viable_uint_t< size > | alphabet_size = size
| The size of the alphabet, i.e. the number of different values it can take.
Protected Types inherited from seqan3::alphabet_base< derived_type, size, char_t >
using | char_type = std::conditional_t<std::same_as<char_t, void>, char, char_t>
| The char representation; conditional needed to make semi alphabet definitions legal.
using | rank_type = detail::min_viable_uint_t<size - 1>
| The type of the alphabet when represented as a number (e.g. via to_rank()).

## Detailed Description

A 16 letter DNA alphabet, containing all IUPAC symbols minus the gap and plus an equality sign ('=').

The seqan3::dna16sam alphabet is the nucleotide alphabet used inside the SAM, BAM and CRAM formats. It has all the letters of the seqan3::dna15 alphabet and the extra alphabet character '=' which denotes a nucleotide character identical to the reference. Without the context of this reference sequence, no assumptions can be made about the actual value of '=' letter.

Note that you can assign 'U' as a character to dna16sam and it will silently be converted to 'T'. Lower case letters are accepted when assigning from char (just like seqan3::dna15) and unknown characters are silently converted to 'N'.

The complement is the same as for seqan3::dna15, with the addition that the complement of '=' is unknown and therefore set to 'N'.

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/nucleotide/dna16sam.hpp>
#include <seqan3/core/debug_stream.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::dna16sam letter{'A'_dna16sam};
letter.assign_char('=');
seqan3::debug_stream << letter << '\n'; // prints "="
letter.assign_char('F'); // Unknown characters are implicitly converted to N.
seqan3::debug_stream << letter << '\n'; // "N";
}
seqan3::alphabet_base::assign_char
constexpr derived_type & assign_char(char_type const chr) noexcept
Assign from a character, implicitly converts invalid characters.
Definition alphabet_base.hpp:160
seqan3::dna16sam
A 16 letter DNA alphabet, containing all IUPAC symbols minus the gap and plus an equality sign ('=').
Definition dna16sam.hpp:45
debug_stream.hpp
Provides seqan3::debug_stream and related types.
dna16sam.hpp
Provides seqan3::dna16sam.
seqan3::debug_stream
debug_stream_type debug_stream
A global instance of seqan3::debug_stream_type.
Definition debug_stream.hpp:38
seqan3::literals
The SeqAn namespace for literals.

This entity is stable. Since version 3.1.

## Friends And Related Symbol Documentation

## dna16sam_vector

using dna16sam_vector = std::vector<dna16sam>

related

Alias for a std::vector of seqan3::dna16sam.

This entity is stable. Since version 3.1.

## operator""_dna16sam() [1/2]

dna16sam_vector operator""_dna16sam | ( | char const * | s,
|  | size_t | n )

related

The seqan3::dna16sam string literal.

Returns
  seqan3::dna16sam_vector

Parameters

  [in] | s | The string literal to assign from.
  [in] | n | The length of the string literal s.

You can use this string literal to easily assign to seqan3::dna16sam_vector:

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
// generated from test/snippet/alphabet/nucleotide/@target_alphabet@_literal.cpp.in
#include <seqan3/alphabet/nucleotide/dna16sam.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::dna16sam_vector sequence1{"ACGTTA"_dna16sam};
seqan3::dna16sam_vector sequence2 = "ACGTTA"_dna16sam;
auto sequence3 = "ACGTTA"_dna16sam;
}

This entity is stable. Since version 3.1.

## operator""_dna16sam() [2/2]

dna16sam operator""_dna16sam | ( | char const | c | ) |

related

The seqan3::dna16sam char literal.

Returns
  seqan3::dna16sam

Parameters

  [in] | c | The character to assign from.

You can use this char literal to assign a seqan3::dna16sam character:

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
// generated from test/snippet/alphabet/nucleotide/@target_alphabet@_char_literal.cpp.in
#include <seqan3/alphabet/nucleotide/dna16sam.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::dna16sam letter1{'A'_dna16sam};
auto letter2 = 'A'_dna16sam;
}

This entity is stable. Since version 3.1.

The documentation for this class was generated from the following file:

- dna16sam.hpp

Hide me